using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using WINDF7CSharp;

namespace Flash
{
    public partial class FlashForm : Form
    {
        double Ks, T1, T2, d, wo, F_st, Kr, R1, R2, R3, C1, C2, ue, F_phir, tmax;

        string d0d1, notpossible, flashimpossible;
        FormMain meinMain;
        private double phirStart = 60;


        public FlashForm(FormMain parent)
        {
            InitializeComponent();
            meinMain = parent;
            d0d1 = "Value of d is not OK (0<d<1!!!=)";
            notpossible = "st<1 is not possible with this circuit!!!";
            flashimpossible = "Flash design not possiblebecause of delay is not zero";
            textBox10.Text = phirStart.ToString("F0");
            textBox10_Leave(null, null);
            textBox1_Leave(null, null);
            meinMain = parent;
        }

        public void deutsch()
        {
            d0d1 = "Wert d ist nicht OK (0<d<1 !!!)";
            notpossible = "st<1 ist mit dieser Schaltung nicht mglich";
            this.Text = "Blitzregler-Auslegung";
            toolStripButtonCompute.ToolTipText = "Berechne den Regler neu";
            toolStripButtonReport.ToolTipText = "Zum Report";
            toolStripButtonClose.ToolTipText = "Schlieen uns Verferfen der Ergebnisse";
            toolStripButtonOK.ToolTipText = "Schlieen und bernehmen der Ergbenisse";
            groupBox4.Text = "Regler: PIDT1";
            groupBox1.Text = "Strecke:   2PT1";
            groupBox2.Text = "Dmpfung des geschlossenen Kreises";
            label25.Text = "Entwurfs-Parameter";
            groupBox3.Text = "Schnelligkeit des geschlossenen Kreises";
            label29.Text = "Schaltung";
            label23.Text = "Klicke hier fr einen neuen PIDT1-Entwurf";
            flashimpossible = "Blitzentwurf ist nicht mglich, da Totzeit nicht Null";
            button1.Text = "Ignoriere Tz";
            button2.Text = "Gehe zum FKL";
        }

        private double phasenReserve(double d)
        {
            return (90.0 - 180.0 / Math.PI * Math.Atan(Math.Sqrt(Math.Sqrt(0.25 + 1.0 / Math.Pow(Math.Pow(2.0 * d, 2), 2)) - 0.5)));
        }

        private double daempfung(double phi)
        {
            double x;
            x = Math.PI / 180.0 * (90.0 - phi);
            return (0.5 * Math.Sqrt(Math.Sqrt(1.0 / (Math.Pow(Math.Pow(Math.Sin(x) / Math.Cos(x), 2) + 0.5, 2) - 0.25))));
        }

        private String doubleToSring(double d)
        {
            string help=d.ToString("G6");
            //if (help.Length > 10) help = String.Format("{0:e}", d);
            return help;
        }

        public void textBox1_Leave(object sender, EventArgs e)
        {
            double h1 = 0, h2 = 0;
            meinMain.ConvertToDouble(textBoxTz.Text, ref h1);
            meinMain.ConvertToDouble(textBox2.Text, ref h2);
            if ((h1 / h2 > 1e-7))
            {
                groupBox6.Visible = true;
            }
            meinMain.ConvertToDouble(textBox1.Text, ref Ks);
            meinMain.ConvertToDouble(textBox2.Text, ref T1);
            meinMain.ConvertToDouble(textBox3.Text, ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox8.Text, ref d);
            meinMain.ConvertToDouble(textBox12.Text, ref F_st);
            meinMain.ConvertToDouble(textBox16.Text, ref R1);
            if (d <= 0) MessageBox.Show(d0d1);

            else
            {
                if (d < 1)
                {
                    ue = Math.Exp(-d * Math.PI / Math.Sqrt(1 - d * d));
                    textBox9.Text = ue.ToString("G6");
                }
                else textBox9.Text = "no ";// d>=1

                F_phir = phasenReserve(d);
                textBox10.Text = doubleToSring(F_phir);
            }
            wo = F_st / 2 / d / T2;
            if (d < 1) tmax = Math.PI / wo / Math.Sqrt(1 - d * d); else tmax = 1e10;
            Kr = T1 * F_st / (4 * d * d * Ks * T2);
            textBox11.Text = doubleToSring(wo);
            textBox13.Text = doubleToSring(Kr);
            textBox14.Text = doubleToSring(tmax);
            double help = Kr * F_st;
            textBox15.Text = doubleToSring(help);
            textBox4.Text = doubleToSring(Kr);
            textBox5.Text = doubleToSring(T1);
            textBox6.Text = doubleToSring(T2);
            textBox7.Text = doubleToSring(F_st);
            R2 = R1 * Kr; C2 = T1 / R2 * 1000.0;
            if (F_st > 1) { R3 = R1 / (F_st - 1); C1 = T2 / F_st / R3 * 1000.0; }
            else { R3 = 0; C1 = 0; }

            textBox17.Text = doubleToSring(C2);
            textBox18.Text = doubleToSring(R2);
            textBox19.Text = doubleToSring(C1);
            textBox20.Text = doubleToSring(R3);
            panel2.Visible = false;

        }

        private void textBox10_Leave(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(textBox10.Text,ref F_phir );
            d = daempfung(F_phir);
            textBox8.Text = doubleToSring(d);
            textBox1_Leave(sender, e);

        }

        private void textBox9_Leave(object sender, EventArgs e)
        {
            double lnue;
            string s= textBox9.Text;
            if (s != "no ")
            {
                meinMain.ConvertToDouble(s,ref ue );
                if (ue > 0)
                {
                    lnue = Math.Log(ue);
                    d = -lnue / Math.Sqrt(Math.PI * Math.PI + lnue * lnue);
                    textBox8.Text = doubleToSring(d);
                    textBox1_Leave(sender, e);
                }
            }
        }

        private void textBox11_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if wo is given */
            meinMain.ConvertToDouble(textBox2.Text,ref T1 );
            meinMain.ConvertToDouble(textBox3.Text,ref T2 );
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox8.Text,ref d ); ;
            meinMain.ConvertToDouble(textBox11.Text,ref wo );
            F_st = 2 * d * T2 * wo;
            textBox12.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox13_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if Kr is given */
            meinMain.ConvertToDouble(textBox1.Text,ref Ks );
            meinMain.ConvertToDouble(textBox2.Text,ref T1 );
            meinMain.ConvertToDouble(textBox3.Text,ref T2 );
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox8.Text,ref  d );
            meinMain.ConvertToDouble(textBox13.Text,ref Kr );
            F_st = 4.0 * d * d * Ks * Kr * T2 / T1;
            textBox12.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox14_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if tmax is given */
            meinMain.ConvertToDouble(textBox2.Text,ref T1 );
            meinMain.ConvertToDouble(textBox3.Text,ref T2 );
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox8.Text,ref d );
            meinMain.ConvertToDouble(textBox14.Text,ref tmax );
            F_st = 2 * d * T2 * Math.PI / tmax / Math.Sqrt(1 - d * d);
            textBox12.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox15_Leave(object sender, EventArgs e)
        {
            double h1, ymax=0;
            /*if ymax=krst is given */
            meinMain.ConvertToDouble(textBox1.Text,ref Ks );
            meinMain.ConvertToDouble(textBox2.Text,ref T1 );
            meinMain.ConvertToDouble(textBox3.Text,ref T2 );
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox8.Text,ref d);
            meinMain.ConvertToDouble(textBox15.Text,ref ymax );
            F_st = 2 * d * Math.Sqrt(Ks * ymax * T2 / T1);
            textBox12.Text = doubleToSring(F_st);
            textBox1_Leave(sender, e);
        }

        private void textBox17_Leave(object sender, EventArgs e)
        {
            double h1;
            /*if C2 is given */
            meinMain.ConvertToDouble(textBox17.Text,ref C2 );
            meinMain.ConvertToDouble(textBox5.Text,ref T1 );
             meinMain.ConvertToDouble(textBox6.Text,ref T2);
            if (T2 > T1) { h1 = T1; T1 = T2; T2 = h1; }
            meinMain.ConvertToDouble(textBox4.Text,ref Kr );
            R1 = T1 / (Kr * C2 * 0.001);
            textBox16.Text = doubleToSring(R1);
            textBox1_Leave(sender, e);
        }

        private void textBox4_Leave(object sender, EventArgs e)
        {

            string Krold, T1old, T2old, F_stold;
            meinMain.ConvertToDouble(textBox16.Text,ref R1 );
            Krold = Kr.ToString("G6");
            T1old = T1.ToString("G6");
            T2old = T2.ToString("G6");
            F_stold = F_st.ToString("G6");
            if ((textBox4.Text != Krold) || (textBox5.Text != T1old) || (textBox6.Text != T2old) || (textBox7.Text != F_stold))
            {
                panel2.Top = 43; panel2.Left = 12;
                panel2.Width = 230;
                panel2.Height = 480;
                panel2.Visible = true;
             
            }
            meinMain.ConvertToDouble(textBox4.Text,ref Kr );
            meinMain.ConvertToDouble(textBox5.Text,ref T1 );
            meinMain.ConvertToDouble(textBox6.Text,ref T2 );
            meinMain.ConvertToDouble(textBox7.Text,ref F_st );

            R2 = R1 * Kr; C2 = T1 / R2 * 1000.0;
            if (F_st < 1) MessageBox.Show(notpossible);
            else
                if (F_st > 1) { R3 = R1 / (F_st - 1); C1 = T2 / F_st / R3 * 1000.0; }
                else { R3 = 0; C1 = 0; }

            textBox17.Text = doubleToSring(C2);
            textBox18.Text = doubleToSring(R2);
            textBox19.Text = doubleToSring(C1);
            textBox20.Text = doubleToSring(R3);
         }

        private void button1_Click(object sender, EventArgs e)
        {
            textBoxTz.Text = "0";
            groupBox6.Visible = false;
            label22.Visible = false;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Hide();
            meinMain.fra.Show();
            // If "Yes" then open the FRA- Design
        }

        private void FlashForm_Activated(object sender, EventArgs e)
        {
            textBox1_Leave(sender, e);
            double h1 = 0, h2 = 0;
            meinMain.ConvertToDouble(textBoxTz.Text, ref h1);
            meinMain.ConvertToDouble(textBox2.Text, ref h2);
            if ((h1 / h2 > 1e-7))
            {
                groupBox6.Top = 60;
                groupBox6.Left = 10;
                groupBox6.Visible = true;
                label22.Text = flashimpossible;
                label22.Visible = true;
            }
        }

        private void panel2_Click(object sender, EventArgs e)
        {
            textBox1.Focus();
            textBox1_Leave(sender, e);
            panel2.Visible = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string a = "      ";
            meinMain.tBMainReport.AppendText(a+"____________________________________\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            
            if (!panel2.Visible)
            {
                meinMain.tBMainReport.AppendText(a + this.Text + "\r\n");
                meinMain.tBMainReport.AppendText("\r\n");

                meinMain.tBMainReport.AppendText(a + groupBox1.Text + "\r\n");

                meinMain.tBMainReport.AppendText(a + label1.Text + " = " + textBox1.Text + "  " + label2.Text + " = " + textBox2.Text + " s   " + label3.Text + " = " + textBox3.Text + " s\r\n");
                meinMain.tBMainReport.AppendText("\r\n");
                meinMain.tBMainReport.AppendText(a + label25.Text + "\r\n");
                meinMain.tBMainReport.AppendText(a + groupBox2.Text + "\r\n");
                meinMain.tBMainReport.AppendText(a + label8.Text + " = " + textBox8.Text + "  " + label9.Text + " = " + textBox9.Text + "   " + label10.Text + " = " + textBox10.Text + "\r\n");
                meinMain.tBMainReport.AppendText("\r\n");
                meinMain.tBMainReport.AppendText(a + groupBox3.Text + "\r\n");
                meinMain.tBMainReport.AppendText(a + label11.Text + " = " + textBox11.Text + " 1/s  " + label12.Text + " = " + textBox12.Text + "   " + label13.Text + " = " + textBox13.Text + "\r\n");
                meinMain.tBMainReport.AppendText(a + label14.Text + " = " + textBox14.Text + " s  " + label15.Text + " = " + textBox15.Text + "   " + "\r\n");
            }
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + groupBox4.Text + "\r\n");
            meinMain.tBMainReport.AppendText(a + label4.Text + " = " + textBox4.Text + "  " + label5.Text + " = " + textBox5.Text + " s   " + "\r\n");
            meinMain.tBMainReport.AppendText(a + label6.Text + " = " + textBox6.Text + " s  " + label7.Text + " = " + textBox7.Text + "   " + "\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + label29.Text + "\r\n");
            meinMain.tBMainReport.AppendText(a + label16.Text + " = " + textBox16.Text + " kOhm\r\n");
            meinMain.tBMainReport.AppendText(a + label17.Text + " = " + textBox17.Text + " F\r\n");
            meinMain.tBMainReport.AppendText(a + label18.Text + " = " + textBox18.Text + " kOhm\r\n");
            meinMain.tBMainReport.AppendText(a + label19.Text + " = " + textBox19.Text + " F\r\n");
            meinMain.tBMainReport.AppendText(a + label20.Text + " = " + textBox20.Text + " kOhm\r\n");
            meinMain.tBMainReport.AppendText(a + "____________________________________\r\n");
            }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Hide();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            Hide();
            // Copy results into KT->pq window
            meinMain.fpidpq.textBox1.Text = textBox4.Text;// KR
            meinMain.fpidpq.textBox2.Text = textBox5.Text;//Tn
            meinMain.fpidpq.textBox3.Text = textBox6.Text;//Tv
            meinMain.fpidpq.textBox4.Text = textBox7.Text;//st
            meinMain.fpidpq.labelDontFit.Visible = true;
        }

 
        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox1_Leave(sender, e);
        }

        private void textBox9_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox9_Leave(sender, e);
        }

        private void textBox10_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox10_Leave(sender, e);
        }

        private void textBox11_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox11_Leave(sender, e);
        }

        private void textBox13_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox13_Leave(sender, e);
        }

        private void textBox14_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox14_Leave(sender, e);
        }

        private void textBox15_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox15_Leave(sender, e);
        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox4_Leave(sender, e);
        }

        private void textBox17_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x0d) textBox17_Leave(sender, e);
        }

        private void FlashForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;

        }
          
            
        }
    
}