﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using WINDF7CSharp;


namespace ZPR
{
    public partial class FormZPR : Form
    {
        bool inpcurve;  // true if a simulated or file curve available
        double toff, ton, tmin, _tmax, _xmin, _xmax, _wo;

        double _tz = 0;
        double _t1 = 1;
        double _t2 = 0.1;
        double ks = 1, _B;

        int anzpunkteI, pointnb, nbofcurves;
        double xmaxI, xminI, ymaxI, yminI;



        String pts,cvs,Imported,
              Identified,identdata,Simulated,Rnocurve; // aus U_regress
        String clickright, cr = "\x0d" + "\x0a";

        String numbersfit = "<--numbers fit together-->",
            numbersdontfit = "<--numbers don''t fit-->",
            Error1nozerofound = "Error 1 : no zero found ,perhaps no pure 2PT1 ",
            Error2t2Searchfailed = "Error 2 : t2-Search failed (steps>40)",
            Error3t1Searchfailed = "Error 3 : t1-Search failed (steps>40)",
            Error4inputvalnotrightorder = "Error 4 : input values not in the right order",
            Error57nozeroderivat = "Error 5-7 : no zero of derivative, no minimum ",
            Error89nostartval = "Error 8,9 : no starting values for zero search ",
            Label1Text="Measurement",
            Label2Text="Model";


//---------------------------------------------------------------------------

        ///////////////
        /*KONSTRUKTOR*/
        ///////////////
        FormMain meinMain;



        public FormZPR(FormMain m)
        {
            InitializeComponent();
            meinMain = m;

            identdata = "Curve of Ident Model";
            pts = "Points";
            Simulated = "Simulated";
            Identified = "Identified";
            Imported = "imported";
            Rnocurve = "no curve";
            cvs = "Curves";

            anzpunkteI = (int)CSpinEdit1.Value;
            inpcurve = false; // No curve / t - values so ident curve could not drawn
            nbofcurves = 1;



            clickright = "Click right on ";



        }

//---------------------------------------------------------------------------

        //Umwandeln von Color zu unsigned int
        private uint ColorToUInt(Color color)
        {
            return (uint)( (color.B << 16) |
                          (color.G << 8) | (color.R << 0));
        }

//---------------------------------------------------------------------------

 //---------------------------------------------------------------------------

        void tbdisable()
        {
            TBDrawidentcurve.Enabled = false;

        }

        //---------------------------------------------------------------------------

        void tbenable()
        {
            TBDrawidentcurve.Enabled = true;

        }
//---------------------------------------------------------------------------
 
        
//---------------------------------------------------------------------------

        private double exps(double x)
        {
          if (x>70) return(1e30);
          else
           if (x<-70) return(0);
           else return(Math.Exp(x));
        }

//---------------------------------------------------------------------------

        private double xsa(double t)
        {
          double ex1,ex2,exa1,exa2,exn1,exn2,x;
          if (t>_tz){
            if (Math.Abs(_t1-_t2)<1e-10) _t2=_t1*(1+1e-10);
            ex1=exps(-(t-_tz)/_t1);
            ex2=exps(-(t-_tz)/_t2);
            if (t>(toff+_tz)){
              exa1=exps(toff/_t1);
              exa2=exps(toff/_t2);
              if (t>(ton+_tz)){
                exn1=exps(ton/_t1);
                exn2=exps(ton/_t2);
                x=1+1/(_t2-_t1)*(_t1*ex1*(1-exa1+exn1)-_t2*ex2*(1-exa2+exn2));
              }
              else x=1/(_t2-_t1)*(_t1*ex1*(1-exa1)-_t2*ex2*(1-exa2));/* toff < t < ton */
            }
            else x=1+1/(_t2-_t1)*(_t1*ex1-_t2*ex2);/* t < toff */
          }  /* t>tz*/ else x=0;
          return(ks*x);
        }  /* xsa() */

//---------------------------------------------------------------------------

        double dx,_a,_b,_c,_d,_e;

        private void gt(double t, ref double g, ref double gs){
          double x,ea,eb,ec,ed,ee;
          x=1/t;
          ea=exps(-_a*x);
          eb=exps(-_b*x);
          ec=exps(-_c*x);
          ed=exps(-_d*x);
          ee=exps(-_e*x);
          g=dx*(ea-eb-ec+1)-ed+ee;
          gs=dx*(_a*ea-_b*eb-_c*ec)-_d*ed+_e*ee;   /* derivative of  g */
        }

//---------------------------------------------------------------------------
        
        private void idzprorg(double toff,double ton,double _tmax,double tmin,double _xmax,double _xmin,
                      ref double ks, ref double t1, ref double t2, ref double tz, ref int error)
        {

          const double epsg=1.0e-8;   /* break zero search */
          const double epsg1=1.0e-4;  /* break Min search */
          const int iend=40;       /* Max iteration */
          double x,anfx,endx,mitx,g=0,gs=0,anft,endt;
          double ax;
          int i;


          error=0;
          tmin=tmin-tz;
          _tmax=_tmax-tz;
          dx=_xmax/_xmin;
          _a=tmin-toff;
          _b=tmin;
          _c=tmin-ton;
          _d=_tmax-toff;
          _e=_tmax;
          if ((toff<=0)||(dx<=1)||(_a<=0)||(_b<=0)||(_c<=0)||(_d<=0)||(_e<=0)){
            error=4;
            return;
          }
          /* Search of Minimum of g (=zero of gs) start searching a valid intervall for (gs */
          i=0;
          x=tmin;
          gt(x, ref g, ref gs);
          while ((gs<0)&&(i<iend)){
            i=i+1;
            x=x*2.0;
            gt(x, ref g, ref gs);
          }
          if (i==iend){
            error=5;
            return;
          }
          endx=x;

          i=0;
          x=tmin;
          gt(x, ref g, ref gs);
          while ((gs>0) &&(i<iend)){
            i=i+1;
            x=x/2.0;
            gt(x, ref g, ref gs);
          }
          if (i==iend){
            error=6;
            return;
          }
          anfx=x;
          /* now there is a zero between anfx &&} x */
          i=0;anft=anfx;endt=endx;

        //    { nested intervalls with pos. gradient for minimum-search of g}
          do{
            x=(anft+endt)/2.0;
            gt(x, ref g, ref gs);
            if (gs>0) endt=x;
            else anft=x;
            i=i+1;
          }
          while (!((Math.Abs(gs) < epsg1) || (i >= iend) || (g < 0)));
          if (i==iend){
            error=7;
            return;
          }
          if (g>0){
            error=1;
            return;
          }
          mitx=x;

        //    { T1/T2-search of the both zeroes of g, start with search for a
        //     valid intervall of g }
          i=0;
          x=mitx;
          gt(x, ref g, ref gs);
          while ((g<0)&&(i<iend)){
            i=i+1;
            x=x*2.0;
            gt(x, ref g, ref gs);
          }
          if (i==iend){
            error=8;
            return;
          }
          endx=x;

          i=0;
          x=mitx;
          gt(x, ref g, ref gs);
          while ((g<0)&&(i<iend)){
            i=i+1;
            x=x/2.0;
            gt(x, ref g, ref gs);
          }
          if (i==iend){
            error=9;
            return;
          }
          anfx=x;

          /* now there is a first zero between mitx &&} x */
          i=0;
          anft=mitx;
          endt=endx;

        //    { nested intervalls with pos. gradient for zero-search of g}
          do{
            x=(anft+endt)/2.0;
            gt(x, ref g, ref gs);
            if (g>0) endt=x;
            else anft=x;
            i=i+1;
          }
          while (!((Math.Abs(g) < epsg) || (i >= iend)));
          if (i==iend){
            error=3;
            return;
          }
          t1=x;
          ax=(1-exps(toff/x))*exps(-_tmax/x);
          ks=-_xmax/ax;

           /* now there is a second zero between anfx &&mitx */

          i=0;
          anft=anfx;
          endt=mitx;
        //    { nested intervalls with negative gradient for zero-search of g}
          do{
            x=(anft+endt)/2.0;
            gt(x, ref g, ref gs);
            if (g<0) endt=x;
            else anft=x;
            i=i+1;
          }
          while (!((Math.Abs(g) < epsg) || (i >= iend)));
          t2=x;
          if (i==iend){
            error=2;
            return;
          }
          if (t2>t1){
            x=t2;
            t2=t1;
            t1=x;
          }
        }   /* idzpr */

//---------------------------------------------------------------------------

        int identzprall(double toff,double ton,double _tmax,double tmin,double _xmax,double _xmin,
                         ref double ks, ref double t1, ref double t2, ref double tz)
          {
          double  dz;
          int error=0;
          if (RBauto.Checked)
          {
              tz = 0;
              dz = (tmin - ton) / 100.0;  /* max nb of steps is 100 */
              /* automatic search of tz */
              do
              {
                  idzprorg(toff, ton, _tmax, tmin, _xmax, _xmin, ref ks, ref t1, ref t2, ref tz, ref error);
                  if (error != 0) tz = tz + dz;
              }
              while (!((error == 0) || ((tmin - tz) < ton)));
          }
          else idzprorg(toff, ton, _tmax, tmin, _xmax, _xmin, ref ks, ref t1, ref t2, ref tz, ref error);
          switch (error){
            case 1: MessageBox.Show(Error1nozerofound);   return(error);
            case 2: MessageBox.Show(Error2t2Searchfailed); return (error);
            case 3: MessageBox.Show(Error3t1Searchfailed); return (error);
            case 4: MessageBox.Show(Error4inputvalnotrightorder); return (error);
            case 5: MessageBox.Show(Error57nozeroderivat); return (error);
            case 6: MessageBox.Show(Error57nozeroderivat); return (error);
            case 7: MessageBox.Show(Error57nozeroderivat); return (error);
            case 8: MessageBox.Show(Error89nostartval); return (error);
            case 9: MessageBox.Show(Error89nostartval); return (error);
          } /*case*/
          return(error);
        }
//---------------------------------------------------------------------------

        private void resetchangeflag()
        {
            Label14.Text = numbersfit;
            Label14.ForeColor = Color.Black;
        }

//---------------------------------------------------------------------------

        private void setchangeflag()
        {
            Label14.Text = numbersdontfit;
            Label14.ForeColor = Color.Red;
            Label15.Text = ""; /*clear sensitivities*/
            Label16.Text = "";
            Label17.Text = "";
            Label18.Text = "";
            Label19.Text = "";
            Label20.Text = "";
            Label21.Text = "";
            Label22.Text = "";
            Label23.Text = "";
        }

//---------------------------------------------------------------------------
        
        ///////////////////////////////////////
        //ab hier click functions von Buttons//
        ///////////////////////////////////////


//---------------------------------------------------------------------------

        private void TBDrawidentcurve_Click(object sender, EventArgs e)
        {// Draw curve 1 with K/T with t- values from Curve 0
            int i;
            double t, yi;
            double[] poi;
            String str;
            chart2D1.Visible = true;
            if (nbofcurves == 2) chart2D1.clearLast();
            nbofcurves = 2;
            double kh = 0, Bh = 0;
            meinMain.ConvertToDouble(Edit7K.Text,ref kh);
            meinMain.ConvertToDouble(Edit12.Text,ref Bh);
            ks = kh * Bh;     // K*B
            meinMain.ConvertToDouble(Edit8T1.Text,ref _t1 );
            meinMain.ConvertToDouble(Edit9T2.Text,ref _t2 );
            meinMain.ConvertToDouble(Edit10Tz.Text,ref _tz );
            //_wo=StrToFloat(Edit11.Text);
            PageControl1.SelectedTab = PageControl1.TabPages[0]; //TBCurve anzeigen
            chart2D1.CurveNames[1] = Identified;
            anzpunkteI = chart2D1.CurvePoints[0];

            double uoffs = 0;
            meinMain.ConvertToDouble(Edoffs.Text,ref uoffs);
            for (i = 0; i <= anzpunkteI - 1; i++)
            {
                poi = chart2D1.getPoint(0, i);//korr start 0
                t = poi[0];
                yi = xsa(t) + uoffs;
                chart2D1.setPoint(1, t, yi);
                if (t > xmaxI) xmaxI = t;
                if (t < xminI) xminI = t;
                if (yi > ymaxI) ymaxI = yi;
                if (yi < yminI) yminI = yi;

            }  /*for (i= ....*/
            chart2D1.autoScaling();
            chart2D1.startDrawing();

            DateTime today = DateTime.Now;
            String dateNow = today.ToString("yyyy - MM - dd");
            String timeNow = today.ToString("HH:mm:ss");
            chart2D1.TopTitle=identdata
                + "   " + dateNow + "   " + timeNow
               + "    " + anzpunkteI.ToString() + pts + "2" + cvs;
            str = "K= " + Edit7K.Text + ", T1= "
               + Edit8T1.Text + ", T2= " + Edit9T2.Text + ", Tz= " + Edit10Tz.Text;

            chart2D1.BottomTitle=str;

            tbenable();
            TB15Save.Enabled = true;
        }

//---------------------------------------------------------------------------

        private void Cancelbtn2_Click(object sender, EventArgs e)
        {
            this.Hide();
        }



//---------------------------------------------------------------------------

        private void OKbt1_Click(object sender, EventArgs e)
        {
            this.Hide();
            meinMain.ZPROK();
        }

//---------------------------------------------------------------------------

        private void TB15Save_Click(object sender, EventArgs e)
        {
            meinMain.frmsavecurve.RefToChart2D = chart2D1;
            if (meinMain.frmsavecurve.WindowState == FormWindowState.Minimized)
                meinMain.frmsavecurve.WindowState = FormWindowState.Normal;
            meinMain.frmsavecurve.Show();
            meinMain.frmsavecurve.BringToFront();
        }

//---------------------------------------------------------------------------

        private void TBLoad_Click(object sender, EventArgs e)
        {
            meinMain.frmLO.ShowDialog();
            if (meinMain.frmLO.DialogResult == DialogResult.OK)
            {
                //toolStripButtonClear_Click(sender, e); // Clear old values
                // Copy Data from LoadOptions into Memo1
                Memo1.Text = meinMain.frmLO.textBox1.Text;
                anzpunkteI = Memo1.Lines.Length-1;//meinMain.frmLO.LO1.
                chart2D1.Visible = true;
                chart2D1.clearAll();
                string fn = System.IO.Path.GetFileName(meinMain.frmLO.openFileDialog1.FileName);
                chart2D1.CurveNames[0] = fn; 
                nbofcurves = 1;
                chart2D1.CurveColor0 = Color.Blue;
                PageControl1.SelectedTab = PageControl1.TabPages[0];//PageControl1->ActivePage = TSCurve;
                // Draw into curve 2, curve 1 is cleared
                CHMinMax chmm = new CHMinMax();
                chmm.init();
                // draw Curve 0
                meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, Memo1,ref chmm ,meinMain.frmLO.LO1);
                nbofcurves = 1;
                DateTime today = DateTime.Now;
                String dateNow = today.ToString("yyyy - MM - dd");
                String timeNow = today.ToString("HH:mm:ss");
                chart2D1.TopTitle=OpenDialog1.FileName.ToString()
                 + "   " + dateNow + "   " + timeNow
                 + "    " + anzpunkteI.ToString() + pts + "1" + cvs;
                chart2D1.BottomTitle = "";


                TBDrawidentcurve.Enabled = true;
                TSData.Text = "ASCII Data " + Imported;
                TB15Save.Enabled = true;
                inpcurve = true;
            }
        }

//---------------------------------------------------------------------------

        private void BAccept_Click(object sender, EventArgs e)
        {
            if (pointnb == 0)
            {
                Edit1.Text = Edfindt.Text;//toff
                Label29.Text = clickright + " tmax";
            }
            if (pointnb == 1)
            {
                Edit2.Text = Edfindt.Text;//tmax
                Edit5.Text = Edfindx.Text;//xmax
                Label29.Text = clickright + " ton";
            }
            if (pointnb == 2)
            {
                Edit3.Text = Edfindt.Text;//ton
                Label29.Text = clickright + " tmin";
            }
            if (pointnb == 3)
            {
                Edit4.Text = Edfindt.Text;//tmin
                Edit6.Text = Edfindx.Text;//xmin
                Label29.Text = "fertig";
                panel2.Visible = false;
///////////////////////////////////////////////////////////
//???? nicht bekannt?!?!?!////////////////////////////////
                //Chartfx1.Cursor = crDefault;
            }
            
            pointnb++;
            if (PageControl1.SelectedTab == PageControl1.TabPages[1])
                Memo1.Focus();
        }

//---------------------------------------------------------------------------

        private void BfindPoints_Click(object sender, EventArgs e)
        {
            panel2.Visible = true;
            Label29.Text = clickright + " toff";
            pointnb = 0;
///////////////////////////////////////////////////////////
//???? nicht bekannt?!?!?!///////////////////////////////
            //Chartfx1->Cursor = crCross;
        }

//---------------------------------------------------------------------------

        private void B2Ident_Click(object sender, EventArgs e)
        {
            int err;
            double uoffs=0;
            meinMain.ConvertToDouble(Edit12.Text,ref _B );
            meinMain.ConvertToDouble(Edit1.Text,ref toff );
            meinMain.ConvertToDouble(Edit2.Text,ref _tmax );
            meinMain.ConvertToDouble(Edit3.Text,ref ton );
            meinMain.ConvertToDouble(Edit4.Text,ref tmin );
            meinMain.ConvertToDouble(Edoffs.Text,ref uoffs );
            meinMain.ConvertToDouble(Edit5.Text,ref _xmax );
            _xmax = _xmax - uoffs;
            meinMain.ConvertToDouble(Edit6.Text,ref _xmin );
            _xmin = _xmin - uoffs;
            meinMain.ConvertToDouble(Edit10Tz.Text,ref _tz );
            err = identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref ks, ref _t1, ref _t2, ref _tz);
            Edit7K.Text = (ks/_B).ToString("G6");//FloatToStrF(ks / _B, ffFixed, 10, 4);
            Edit8T1.Text = _t1.ToString("G6");// FloatToStrF(_t1, ffFixed, 10, 4);
            Edit9T2.Text = _t2.ToString("G6");// FloatToStrF(_t2, ffFixed, 10, 4);
            Edit10Tz.Text = _tz.ToString("G6");// FloatToStrF(_tz, ffFixed, 10, 4);

            _wo = xsa(toff);
            Edit11.Text = _wo.ToString("G6");// FloatToStrF(_wo + uoffs, ffFixed, 10, 4);
            resetchangeflag();
            if ((err == 0)&& (inpcurve))
            {
                TBDrawidentcurve.Enabled = true;
                TBDrawidentcurve_Click(sender, e);
            }
        }

//---------------------------------------------------------------------------

        private void B1Recomp_Click(object sender, EventArgs e)
        {
            const double epsg = 1.0e-10;
            double anft, endt, t, xx;
            double exa1, exa2, exa3, hilf1;
            int i;
            //  /* recomputation of the ton/toff-values from Ks,T1,...*/
            //ks = (meinMain.ConvertToDouble(Edit7.Text)) * (meinMain.ConvertToDouble(Edit12.Text));
            double kh = 0, Bh = 0;
            meinMain.ConvertToDouble(Edit7K.Text, ref kh);
            meinMain.ConvertToDouble(Edit12.Text, ref Bh);
            ks = kh * Bh;     // K*B
            meinMain.ConvertToDouble(Edit8T1.Text, ref _t1);
            meinMain.ConvertToDouble(Edit9T2.Text, ref _t2);
            meinMain.ConvertToDouble(Edit10Tz.Text, ref _tz);

            double h1 = 0, h2 = 0;
            meinMain.ConvertToDouble(Edit11.Text, ref h1);
            meinMain.ConvertToDouble(Edoffs.Text, ref h2);
            _wo = h1 - h2;
            toff = 1e10; ton = 1e11;
            t = (_t1 + _t2);
            while (xsa(t) < _wo) t = t * 2;
            endt = t;
            t = (_t1 + _t2);
            while (xsa(t) > _wo) t = t / 2;
            /* search toff */
            anft = t;
            i = 0;
            //{ nested intervals with positive gradient}
            while ((Math.Abs(xsa(t) - _wo) > epsg) && (i < 30))
            {
                t = (anft + endt) / 2;
                xx = xsa(t);
                if (xx > _wo) endt = t;
                else anft = t;
                i = i + 1;
            }
            toff = t;
            /* search ton */
            anft = t;
            t = t * 2;
            while (xsa(t) > _wo) t = t * 2;
            endt = t;
            i = 0;
            //{ nested intervals with negative gradient}
            while ((Math.Abs(xsa(t) - _wo) > epsg) && (i < 30))
            {
                t = (anft + endt) / 2;
                xx = xsa(t);
                if (xx < _wo) endt = t;
                else anft = t;
                i = i + 1;
            }
            ton = t;
            /* search toff2
            anft=t;t=t*2;
            while (xsa(t)<_wo) t=t*2;
            endt=t;
            i=0;
            //{ nested intervals with positive gradient}
            while ((fabs(xsa(t)-_wo)>epsg)&&(i<30)){
            t=(anft+endt)/2;
            xx=xsa(t);
            if (xx>_wo) endt=t;
            else anft=t;
            i=i+1;
            }
            toff2=t;   */
            exa1 = 1 - exps(toff / _t1);
            exa2 = 1 - exps(toff / _t2);
            exa3 = exa1 + exps(ton / _t1);
            hilf1 = _t1 * _t2 / (_t1 - _t2);
            _tmax = hilf1 * Math.Log(exa2 / exa1);
            _xmax = -ks * exa2 * exps(-_tmax / _t2);
            tmin = hilf1 * Math.Log((exa2 + exps(ton / _t2)) / exa3);
            _xmin = ks * (1 - exa3 * exps(-tmin / _t1));
            tmin = tmin + _tz;
            _tmax = _tmax + _tz;
            Edit1.Text = toff.ToString("G6");
            Edit2.Text = _tmax.ToString("G6");
            Edit3.Text = ton.ToString("G6");
            Edit4.Text = tmin.ToString("G6");
            double uoffs = 0;
            meinMain.ConvertToDouble(Edoffs.Text, ref uoffs);

            Edit5.Text = (_xmax + uoffs).ToString("G6");
            Edit6.Text = (_xmin + uoffs).ToString("G6");
            resetchangeflag();
        }

//---------------------------------------------------------------------------

        private void B3Sensitivity_Click(object sender, EventArgs e)
        {
            double dk, dt1, dt2, kn=0, t1n=0, t2n=0, dkmax, dt1max, dt2max;
            Label15.Text = "±1%"; /*set sensitivities */
            Label16.Text = "±1%";
            Label17.Text = "±1%";
            Label18.Text = "±1%";
            Label19.Text = "±1%";
            Label20.Text = "±1%";

            double uoffs=0;
            meinMain.ConvertToDouble(Edit12.Text,ref _B );
            meinMain.ConvertToDouble(Edit1.Text,ref toff );
            meinMain.ConvertToDouble(Edit2.Text,ref _tmax );
            meinMain.ConvertToDouble(Edit3.Text,ref ton );
            meinMain.ConvertToDouble(Edit4.Text,ref tmin );
            meinMain.ConvertToDouble(Edoffs.Text,ref uoffs );
            meinMain.ConvertToDouble(Edit5.Text,ref _xmax );
            _xmax = _xmax - uoffs;
            meinMain.ConvertToDouble(Edit6.Text,ref _xmin );
            _xmin = _xmin - uoffs;
            meinMain.ConvertToDouble(Edit10Tz.Text,ref _tz );


            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref ks, ref _t1, ref _t2, ref _tz);
            toff = toff * 1.005;       /* change 1.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1max = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2max = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dkmax = Math.Abs((ks - kn) / ks * 200.0);
            toff = toff / 1.005;
            _tmax = _tmax * 1.005;       /* change 2.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1 = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2 = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dk = Math.Abs((ks - kn) / ks * 200.0);
            _tmax = _tmax / 1.005;
            if (dk > dkmax) dkmax = dk;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            ton = ton * 1.005;       /* change 3.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1 = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2 = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dk = Math.Abs((ks - kn) / ks * 200.0);
            ton = ton / 1.005;
            if (dk > dkmax) dkmax = dk;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            tmin = tmin * 1.005;       /* change 4.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1 = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2 = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dk = Math.Abs((ks - kn) / ks * 200.0);
            tmin = tmin / 1.005;
            if (dk > dkmax) dkmax = dk;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            _xmax = _xmax * 1.005;       /* change 5.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1 = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2 = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dk = Math.Abs((ks - kn) / ks * 200.0);
            _xmax = _xmax / 1.005;
            if (dk > dkmax) dkmax = dk;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            _xmin = _xmin / 1.005;       /* change 6.  variable*/
            identzprall(toff, ton, _tmax, tmin, _xmax, _xmin, ref kn, ref t1n, ref t2n, ref _tz);
            dt1 = Math.Abs((_t1 - t1n) / _t1 * 200.0);
            dt2 = Math.Abs((_t2 - t2n) / _t2 * 200.0);
            dk = Math.Abs((ks - kn) / ks * 200.0);
            _xmin = _xmin * 1.005;
            if (dk > dkmax) dkmax = dk;
            if (dt1 > dt1max) dt1max = dt1;
            if (dt2 > dt2max) dt2max = dt2;
            Label21.Text = dkmax.ToString("G3") + "%";// FloatToStrF(dkmax, ffFixed, 4, 1) + "%";
            Label22.Text = dt1max.ToString("G3") + "%";// FloatToStrF(dt1max, ffFixed, 4, 1) + "%";
            Label23.Text = dt2max.ToString("G3") + "%";// FloatToStrF(dt2max, ffFixed, 4, 1) + "%";
        }

//---------------------------------------------------------------------------

        private void BitBtn2report_Click(object sender, EventArgs e)
        {
            String a = "      ",cr="\x0d"+"\x0a";
            meinMain.tBMainReport.AppendText(a + "_____________________________________________________" + cr + cr);
            meinMain.tBMainReport.AppendText(a + Text + cr);
            meinMain.tBMainReport.AppendText(a + cr);

            meinMain.tBMainReport.AppendText(a + "");
            meinMain.tBMainReport.AppendText(a + Label1Text + cr); /*measurment*/
            meinMain.tBMainReport.AppendText(a + "" + cr);
            meinMain.tBMainReport.AppendText(a + Label3.Text + " = " + Edit1.Text + "   " + Label15.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label4.Text + " = " + Edit2.Text + "   " + Label16.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label5.Text + "  = " + Edit3.Text + "   " + Label17.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label6.Text + " = " + Edit4.Text + "   " + Label18.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label7.Text + " = " + Edit5.Text + "   " + Label19.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label8.Text + " = " + Edit6.Text + "   " + Label20.Text + cr);
            meinMain.tBMainReport.AppendText(a + "" + cr);
            meinMain.tBMainReport.AppendText(a + Label2Text + cr); /* model*/
            meinMain.tBMainReport.AppendText(a + "" + cr);
            meinMain.tBMainReport.AppendText(a + Label9.Text + "  = " + Edit7K.Text + "   " + Label21.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label10.Text + " = " + Edit8T1.Text + "   " + Label22.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label11.Text + " = " + Edit9T2.Text + "   " + Label23.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label12.Text + " = " + Edit10Tz.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label13.Text + "  = " + Edit11.Text + cr);
            meinMain.tBMainReport.AppendText(a + Label30.Text + "  = " + Edoffs.Text + cr);
            meinMain.tBMainReport.AppendText(a + "" + cr);
            meinMain.tBMainReport.AppendText(a + RadioGroup1.Text + cr);
            if (RBfixed.Checked) meinMain.tBMainReport.AppendText(a + RBfixed.Text + cr);
            if (RBauto.Checked) meinMain.tBMainReport.AppendText(a + RBauto.Text + cr);
            meinMain.tBMainReport.AppendText(a + "" + cr);
            meinMain.tBMainReport.AppendText(a + Label14.Text + cr); /* fit*/

            meinMain.tBMainReport.AppendText(a + cr);
            meinMain.tBMainReport.AppendText(a + "_____________________________________________________" + cr);
        }

//---------------------------------------------------------------------------

        private void BSimulate_Click(object sender, EventArgs e)
        {
            Panel1.Visible = true;
        }

//---------------------------------------------------------------------------

        private void BitBtnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

//---------------------------------------------------------------------------

        private void BGo_Click(object sender, EventArgs e)
        {//Draw curve with K/T with new t- values
            int i;
            double t, yi, deltat;
            String str;
            double kh = 0, Bh = 0;
            meinMain.ConvertToDouble(Edit7K.Text, ref kh);
            meinMain.ConvertToDouble(Edit12.Text, ref Bh);
            ks = kh * Bh;     // K*B

            meinMain.ConvertToDouble(Edit8T1.Text, ref _t1);
            meinMain.ConvertToDouble(Edit9T2.Text, ref _t2);
            meinMain.ConvertToDouble(Edit10Tz.Text, ref _tz);

            //toolStripButtonClear_Click(sender, e); // Delete old values
            //B1Recomp_Click(sender, e);
            Panel1.Visible = false;
            chart2D1.Visible = true;
            chart2D1.clearAll();
            nbofcurves = 1;
            chart2D1.CurveColor0 = Color.Blue;
            chart2D1.CurveNames[0] = Simulated;  
            PageControl1.SelectedTab = PageControl1.TabPages[0];
            Memo1.Clear();
            anzpunkteI = (int)CSpinEdit1.Value;
            double help = 0;
            meinMain.ConvertToDouble(Edit13.Text, ref help);
            deltat = help / (anzpunkteI - 1);
            t = 0;
            double uoffs = 0;
            meinMain.ConvertToDouble(Edoffs.Text, ref uoffs);
            for (i = 0; i <= anzpunkteI - 1; i++)
            {
                yi = xsa(t) + uoffs;
                chart2D1.setPoint(0, t, yi);
                Memo1.AppendText(t.ToString() + "  " + yi.ToString());
                if (i < anzpunkteI - 1) Memo1.AppendText(cr);
                if (t > xmaxI) xmaxI = t;
                if (t < xminI) xminI = t;
                if (yi > ymaxI) ymaxI = yi;
                if (yi < yminI) yminI = yi;
                t = t + deltat;
            }  /*for (i= ....*/
            chart2D1.autoScaling();
            chart2D1.startDrawing();

            DateTime today = DateTime.Now;
            String dateNow = today.ToString("yyyy - MM - dd");
            String timeNow = today.ToString("HH:mm:ss");
            chart2D1.TopTitle=Simulated
               + "   " + dateNow + "   " + timeNow
               + "    " + anzpunkteI.ToString() + pts + "1" + cvs;
            str = "K= " + Edit7K.Text + ", T1= "
               + Edit8T1.Text + ", T2= " + Edit9T2.Text + ", Tz= " + Edit10Tz.Text;
            chart2D1.BottomTitle = str;


            TB15Save.Enabled = true;
            inpcurve = true;
            tbenable();
        }

//---------------------------------------------------------------------------
        ///////////
        /*Anderes*/
        ///////////

        private void Edit7_Leave(object sender, EventArgs e)
        {
            setchangeflag();
        }

//---------------------------------------------------------------------------

        private void Form1_Activated(object sender, EventArgs e)
        {
        }

//---------------------------------------------------------------------------

        private void Form1_Resize(object sender, EventArgs e)
        {
            int w = this.Size.Width - 548;
            if (w > 100) PageControl1.Width = w;
        }

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

        private void Memo1_Click(object sender, EventArgs e)
        {
            double t=0, yi=0;
            int pos = Memo1.SelectionStart, j = 0, cnt = 0, k, crlf = 0;
            if (Memo1.Lines.Length > 2)
            {
                do
                {
                    k = Memo1.Lines[j].Length;  // +CR/LF
                    cnt = cnt + k + crlf;
                    crlf = 2;
                    j++;
                }
                while (cnt < pos);
                toolStripStatusLabel1.Text = j.ToString() + ":" + (pos - cnt + k).ToString();

                meinMain.datatools.StrTo2Float(Memo1.Lines[j - 1], ref t, ref yi,' ');
                Edfindt.Text = t.ToString("G6");// FloatToStrF(t, ffGeneral, 10, 10);
                Edfindx.Text = yi.ToString("G6");// FloatToStrF(yi, ffGeneral, 10, 10);
            }
              
        }

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

        public void deutsch()
        {
            this.Text = "Identifikation mit der FSA eines Zweipunktreglers";
            B2Ident.Text = "&identifiziere-->";
            B3Sensitivity.Text = "&Empfindlichkeit";
            RBfixed.Text = "&vorgegeben";
            RBauto.Text = "&automat. Suche";
            RadioGroup1.Text = "Totzeit Tz";
            Label1Text = "Messung";
            Label2Text = " Modell :";
            Label14.Text = numbersfit;
            BitBtn2report.Text = "&zum Report";
            tSBReport.ToolTipText = "Schreibe Ergebnisse in den Main-Report";

            Error89nostartval = "Error 8,9 : Keine Anfangswerte für Nullstellensuche ";
            Error1nozerofound = "Error 1 :  Nullstelle nicht gefunden ,vermutlich kein reines 2PT1 ";
            Error2t2Searchfailed = "Error 2 : T2-Suche abgebrochen (>40 Schritte)";
            Error57nozeroderivat = "Error 5-7 : Keine Nullstelle der Ableitung, kein Minimum ";
            Error3t1Searchfailed = "Error 3 : T1-Suche abgebrochen (>40 Schritte)";
            Error4inputvalnotrightorder = "Error 4 : Eingangswerte nicht in richtiger Reihenfolge, oder falsch!";
            numbersfit = "<--Zahlen passen -->";
            numbersdontfit = "<--Zahlen passen nicht -->";
            clickright = "Klick rechts auf ";
            // hints


            OKbt1.ToolTipText = "Schließe Fenster und kopiere Werte falls sinnvoll in K/T1-Felder";
            Cancelbtn2.ToolTipText = "Schließe Fenster und ignoriere Ergebnisse";

            toolTip1.SetToolTip(BitBtnClose, "Schließe Fenster und ignoriere Ergebnisse");
            TB15Save.ToolTipText = "Speichere ASCII Daten als  *.SIM-Datei";
            TBLoad.ToolTipText = "Lade Datei mit Messwerten für Identifikation";

            OpenDialog1.Title = "Lade Datei mit Messwerten";
            TBDrawidentcurve.ToolTipText = "Zeichne eine Kurve mit den in Ident Parameter spezifizierten Werten";

            TSCurve.ToolTipText = "Kurve";
            ButtonInt.ToolTipText = "Lade intern erzeugte Daten in die Identifikation";

            toolTip1.SetToolTip(B2Ident, "Starte Identifikation mit toff, tmax....Werten");
            toolTip1.SetToolTip(B1Recomp, "Berechne toff, tmax....Werte mit gegebenen K, T1, T2-Werten");
            toolTip1.SetToolTip(B3Sensitivity, "Berechne Fehler, wenn sich die toff, tmax... Werte um 1 % ändern");
            toolTip1.SetToolTip(BitBtn2report, "Kopiere Ergebnisse in den Report im Hauptfenster");
            BitBtn2report.Text = "zum Main-Report";
            B3Sensitivity.Text = "Empfindlichkeit";
            B1Recomp.Text = "<--Berechne Punkte";
            B2Ident.Text = "Starte Ident-->";
            BSimulate.Text = "Simulation";
            BitBtnClose.Text = "Schließen";
            toolTip1.SetToolTip(BSimulate, "Simuliere eine Messkurve mit den gegebenen K, T1, T2-Werten");
            toolTip1.SetToolTip(BGo, "Starte Berechnung und zeichne Kurve");
            toolTip1.SetToolTip(BfindPoints, "Findet mit Hilfe rechter Maus-Klicks die Messpunkte aus Kurve");
            BfindPoints.Text = "Findet Punkte";
            toolTip1.SetToolTip(BAccept, "Akzeptiere Werte und kopiere nach toff, tmax....");
            Simulated = "Simuliert";
            Identified = "Identifiziert";
            Imported = "Aus Datei";
            chart2D1.Germanlanguage = true;
        }

        private void FormZPR_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

  
        private void FormZPR_Load(object sender, EventArgs e)
        {
            B1Recomp_Click(sender, e);
            tbdisable();
            textBoxLeer.Text = "0 0";
            textBoxLeer.AppendText(cr+"0 0");
        }

        private void chart2D1_CoordClick(object sender, ChartTool.CoordClickEventArgs e)
        {    // Auto point finder with Click
                    Edfindt.Text = e.x.ToString();
                    Edfindx.Text = e.y.ToString();

        }

        private void ButtonInt_Click(object sender, EventArgs e)
        {

        }

     }
}